/**
 * All the scripts needed the events custom post type
 */

class SGC_Event {

    constructor( group_data, group_display, group_summary) {
        SGC_Event.group_data = group_data;
        SGC_Event.group_display = group_display;
        SGC_Event.group_summary = group_summary;

        SGC_Event.player_list = [];
        SGC_Event.group_list = [];
        
        SGC_Event.load_group();
    }

    /**
     * 
     */
    location_change() {
        var location_id = $(this).find('option:selected').val();
        var tee_select_html = $(this).attr('tee_select_html');
        var tee_color = $(this).attr('tee_color');
        
        if (location_id > 0) {       
            SGC_Event.display_tees( location_id, tee_select_html, tee_color );
        } else {
            SGC_Event.hide_tees( tee_select_html );
        }
    }
    
    /**
     * 
     */
    static display_tees( location_id, tee_select_html, tee_color ) {
        //Clear tee_select_html
        $( tee_select_html ).html('<option value="">' + SGCtxt.opt_anytee + '</option>');
        
        // Fetch the Tee List
        $.getJSON(SGCtxt.url_site + SGCtxt.url_rest + '/location/tees/' + location_id, function (result) {
            // Build the tee_select_html list
            result.forEach(function( tee ) {
                if ( tee.color === tee_color ) {
                    $( tee_select_html ).append('<option value="' + tee.color 
                            + '" selected="selected">' + tee.color 
                            + ' (' + tee.difficulty + ')' + '</option>');
                } else {
                    $( tee_select_html ).append('<option value="' + tee.color 
                            + '">' + tee.color 
                            + ' (' + tee.difficulty + ')' + '</option>');
                }
            });
        }).done(function ( ) {
            // Enable the element
            $(tee_select_html).prop( 'disabled', false );
        });
    }
    
    /**
     * 
     */
    static hide_tees( tee_select_html ) {
        //Clear element
        $(tee_select_html).html('<option value="">' + SGCtxt.opt_anytee + '</option>');
        
        // Disable element
        $(tee_select_html).prop( 'disabled', true );
    }
    
    /**
     * 
     */
    static load_group() {
        if ( $(SGC_Event.group_data).text() !== '' ) {
            SGC_Event.group_list = JSON.parse( $(SGC_Event.group_data).text() )
        }
        
        SGC_Event.display_group_summary();
    }
    
    /**
     * 
     */
    manage_groups () {
        var team_id = $($(this).attr('team_select')).find('option:selected').val();
        
        // Get existing group list
        if ( $($(this).attr('group_list')).html() != '' ) {
            SGC_Event.group_list = JSON.parse( $($(this).attr('group_list')).html() );
        } else {
            SGC_Event.group_list = [];
        }
        
        // Fetch the player list for the event
        $.getJSON(SGCtxt.url_site + SGCtxt.url_rest + '/event/players/' + $('#post_ID').val(), function ( result ) {
            SGC_Event.player_list = result;
        }).done( function ( ){
            // If this event doesn't have a player list grab the players from the team ID
            if ( SGC_Event.player_list === undefined || SGC_Event.player_list.length == 0 ){
                $.getJSON(SGCtxt.url_site + SGCtxt.url_rest + '/team/players/' + team_id, function ( team_result ) {
                    SGC_Event.player_list = team_result;
                }).done( function ( ){
                    SGC_Event.display_group_list( );
                });
            }
            SGC_Event.display_group_list( );
        });
    }
    
    /**
     * 
     */
    static display_group_list( ) {
        // Clear the grouplist
        $(SGC_Event.group_display).html('');

        // Exit early if we don't have a group
        if ( !Array.isArray(SGC_Event.group_list) || SGC_Event.group_list.length < 1 ) { return 0; }
        
        // Loop through the group array and build the group dialogs
        SGC_Event.group_list.forEach(function ( group, group_idx ) {
            // Create the group container
            $(SGC_Event.group_display).append('<div class="sgc-event-group" id="sgc_event_group_' + group_idx + '"'
                + ' style="display: inline-block"></div>');
            
            // Don't allow blank names
            if ( group.name == '' ) { group.name = SGCtxt.txt_group + ' #' + eval( group_idx + ' + 1' ) ; }
                
            // Add the group Heading
            $('#sgc_event_group_' + group_idx).append('<div>'
                + '<input type="text" id="sgc_event_group_' + group_idx + '_name" placeholder="' 
                + SGCtxt.opt_groupname + '" group_id="' + group_idx
                + '" value="' + group.name + '"/>'
                + '<a href="" id="sgc_event_group_' + group_idx + '_delete" group_id="' 
                + group_idx + '">' + SGCtxt.txt_delete +'</a>'
                + '</div>');
                
            // bind group heading events
            $('#sgc_event_group_' + group_idx + '_delete').click(SGC_Event.delete_group);
            $('#sgc_event_group_' + group_idx + '_name').change(SGC_Event.update_group_name);
            
            // Add player selection list
            $('#sgc_event_group_' + group_idx).append('<div>'
                        + '<select id="sgc_event_group_' + group_idx + '_player_list">'
                        + '<option value="">' + SGCtxt.opt_selectplayer + '</option>'
                        + '</select>'
                        + '<a href="" id="sgc_event_group_' + group_idx + '_player_add" group_id="' 
                        + group_idx + '" player_select="#sgc_event_group_' + group_idx + '_player_list">'
                        + SGCtxt.txt_add + '</a>' + '</div>');
            
            // Populate the player selection list
            SGC_Event.player_list.forEach( function( player ) {
                var checked_in = '';
                if( player.checkedin === 'TRUE' ) { 
                    checked_in = ' &#9989' 
                }
                
                $('#sgc_event_group_' + group_idx + '_player_list').append(
                        '<option value="' + player.ID
                        + '" name="' + player.name
                        + '" URL="' + player.URL
                        + '">' + player.name + checked_in + '</option>');
            });
            
            // Bind player selection list events
            $('#sgc_event_group_' + group_idx + '_player_add').click(SGC_Event.add_player);
            
            // Add the group player list body
            $('#sgc_event_group_' + group_idx).append('<div class="sgc-event-group-players"'
                + 'id="sgc_event_group_' + group_idx + '_players">'
                + '<ul id="sgc_event_group_' + group_idx + '_player_list"></ul>'
                + '</div>');
                
            
            // Populate the group player list body
            group.players.forEach( function ( player, player_idx ) {
                $('ul[id=sgc_event_group_' + group_idx + '_player_list]').append(
                        '<li class="sgc-event-group-player-list"><a href="' + player.URL + 
                        '" target="Player">' + player.name + '</a> - <small><a href="" id="sgc_event_group_'
                        + group_idx + '_player_delete" player_id="' + player_idx
                        + '" group_id="' + group_idx + '">Delete</a></small></li>');
                
                // Bind player delete events
                $('#sgc_event_group_' + group_idx + '_player_delete').click(SGC_Event.delete_player);
            });
        });
    }
    
    /**
     * 
     */
    static display_group_summary() {
         // Clear the group summary
        $(SGC_Event.group_summary).html('<ul id="sgc_event_group_summary_list" '
                + 'class="sgc-event-group-summary"></ul>');

        // Exit early if we don't have a group
        if ( !Array.isArray(SGC_Event.group_list) || SGC_Event.group_list.length < 1 ) { return 0; }
        
        // Loop through the groups
        SGC_Event.group_list.forEach(function ( group, idx ) {
            $('#sgc_event_group_summary_list').append('<li class="sgc-event-group-item">' 
                + group['name'] + ' (' + group['players'].length + ')' + '</li>');
        });
    }
    
    /**
     * 
     */
    add_group() {
        // Add a blank group to the array
        SGC_Event.group_list.push({
            'name' : '',
            'players' : []
        });

        SGC_Event.display_group_list();
        return false;
    }
    
    /**
     * 
     */
    static delete_group( ) {
        var group_idx = $(this).attr('group_id');
        SGC_Event.group_list.splice(group_idx, 1);
        SGC_Event.display_group_list( );
        return false;
    }
    
    /**
     * 
     */
    static update_group_name() {
        var group_idx = $(this).attr('group_id');
        SGC_Event.group_list[group_idx].name = $(this).val();
        SGC_Event.display_group_list( );
    }
    
    /**
     * 
     */
    static add_player() {
        var group_idx = $(this).attr('group_id');
        var player_id = $($(this).attr('player_select')).find('option:selected').val();
        var add_player = true;
        // Exit early on invalid player
        if ( player_id < 0 ) { return false; }
        
        // Don't add a player already on this list
        SGC_Event.group_list[group_idx].players.forEach( function ( player ) {
            if( player.ID == player_id ) { add_player = false; }
        });
        
        // find the matching player id and add them to the group
        if( add_player ) {
            SGC_Event.player_list.forEach( function ( player ) {
                if ( player.ID == player_id ) {
                    SGC_Event.group_list[group_idx].players.push({'ID': player.ID, 'name': player.name, 'URL': player.URL});
                    SGC_Event.display_group_list();
                    return false;
                }
            });
        }
        
        return false;
    }
    
    /**
     * 
     */
    static delete_player() {
        var group_id = $(this).attr('group_id');
        var player_id = $(this).attr('player_id');
        
        // Exit early for invalid values
        if ( group_id < 0 || player_id < 0 ) { return false; }
        
        //remove the player
        SGC_Event.group_list[group_id].players.splice(player_id, 1);
        SGC_Event.display_group_list();
        return false;
    }
    
    /**
     * 
     */
    save_group_list() {
        // Save the array to the form element
        if (SGC_Event.group_list.length > 0) {
            $(SGC_Event.group_data).text(JSON.stringify(SGC_Event.group_list));
        } else {
            $(SGC_Event.group_data).text('[]');
        }
        
        SGC_Event.display_group_summary();
        
        // close the thickbox
        tb_remove();
        
        return false;
    }
    
}
