/**
 * All the scripts needed the events custom post type
 */

class SGC_Player {
    
    constructor ( team_data, team_container ) {
        SGC_Player.team_list = [];
        SGC_Player.team_data = team_data;               // Location to store the team array
        SGC_Player.team_container = team_container;     // Locaiton to display the team info
        
        SGC_Player.get_team_list();
        SGC_Player.display_team_list();
    }
    
    /**
     * 
     */
    add_team() {
        var team_select = $(this).attr('source');
        
        if ( $(team_select).find('option:selected').attr('value') === "" ) {
            return false;
        }
        // get selected option values
        var selected = {
            'ID' : $(team_select).find('option:selected').attr('value'),
            'name' : $(team_select).find('option:selected').attr('name'),
            'URL' : $(team_select).find('option:selected').attr('url')
        };
        
        // Make sure this team isn't already on the list
        var teamexists = false;
        SGC_Player.team_list.forEach(function ( team ) {
            if( team.ID === selected.ID ) {
                teamexists = true;
            }
        });
        if ( teamexists ) { return false; }
        
        // Add team
        SGC_Player.team_list.push( selected );
        SGC_Player.save_team();
        
        SGC_Player.display_team_list();
        
        return false;
    }
    
    /**
     * 
     */
    static delete_team() {
        var team_id = $(this).attr('team_id');
        
        // loop through the list of teams and remove the matching ID
        for (var i = 0; i < SGC_Player.team_list.length; i++) {
            if (SGC_Player.team_list[i].ID === team_id) {
                SGC_Player.team_list.splice(i, 1);
                SGC_Player.save_team();
                SGC_Player.display_team_list();
                return false;
            }
        }
        return false;
    }
    
    /**
     * 
     */
    static save_team() {
        console.log(JSON.stringify(SGC_Player.team_list));
        $(SGC_Player.team_data).html(JSON.stringify(SGC_Player.team_list));
    }
    /**
     * 
     */
    static get_team_list() {
        var team_list = $(SGC_Player.team_data).html().trim();
        if( team_list !== '' ) {
            SGC_Player.team_list = JSON.parse( $(SGC_Player.team_data).html().trim() );
        } else {
            SGC_Player.team_list = [];
        }
    }
    
    /**
     * 
     */
    static display_team_list() {
        // Clear the existing list
        $(SGC_Player.team_container).html('<ul class="sgc-player-team" id="sgc_player_team"></ul>');
        
        // Append the list of teams
        SGC_Player.team_list.forEach(function ( team ) {
            $('#sgc_player_team').append(
            '<li class="sgc-player-team"><a href="' + team['URL'] + '" target="Team">' + team['name'] + '</a> - '
            + '<small><a href="" id="sgc_delete_team_' + team['ID'] + '" team_id="' + team['ID'] + '">'
            + 'Delete</a></small></li>');
    
            $('#sgc_delete_team_' + team['ID']).click(SGC_Player.delete_team);
        });
        
        return false;
    }
}
