<?php

/**
* Provide ui for entering in date/time
*
* This file is used to markup the admin-facing aspects of the plugin.
*
* @link       https://bitbucket.org/matthewlinton/
* @since      1.0.0
*
* @package    Simplegolfclub
* @subpackage Simplegolfclub/admin/partials
*/
?>

<?php add_thickbox(); ?> 

<input type="hidden" id="sgc_javascript" value="sgc_event">
<div class="sgc-container">
    <table class="formtable">
        <tbody>
            <tr>
                <th><label for="sgc_event_date"><?= __('Date') ?></label></th>
                <td>
                    <input type="text" name="sgc_event_date" id="sgc_eventdate" 
                           placeholder="<?= __('Date...') ?>" 
                           value="<?php
                           if ($event_date) {
                               echo $event_date;
                           }
                           ?>" />
                    <script type="text/javascript">$("#sgc_eventdate").pickadate(
                            {format: 'mmmm d yyyy'})</script>
                </td>
            </tr>
            <tr>
                <th><label for="sgc_event_time"><?= __('Time') ?></label></th>
                <td>
                    <input type="text" name="sgc_event_time" id="sgc_eventtime" 
                           placeholder="<?= __('Time...') ?>" 
                           value="<?php
                           if ($event_time) {
                               echo $event_time;
                           }
                           ?>" />
                    <script type="text/javascript">$("#sgc_eventtime").pickatime(
                           {min: [9, 0], max: [20, 0]})</script>
                </td>
            </tr>
            <tr>
                <th><label for="sgc_event_location"><?= __('Location') ?></label></th>
                <td>
                    <select name="sgc_event_location" id="sgc_event_location" 
                            event_id="<?= get_the_ID() ?>" tee_select_html="#sgc_event_tee" 
                            tee_color="<?= $event_tee ?>">
                        <option value="-1"><?= __('Select Location...') ?></option>
                        <?php foreach ($locations as $locaiton) : ?> 
                            <option value="<?= $locaiton->ID ?>" 
                                <?php selected($locaiton->ID, $event_location); ?>>
                                <?= $locaiton->post_title ?></option>
                        <?php endforeach; ?>
                    </select>
                </td>
            </tr>
            <tr>
                <th><label for="sgc_event_team"><?= __('Team') ?></label></th>
                <td>
                    <select name="sgc_event_team" id="sgc_event_team">
                        <option value=""><?= __('Select Team...') ?></option>
                        <?php foreach ($teams as $team) : ?>
                            <option value="<?= $team->ID ?>" 
                                <?php selected($team->ID, $event_team); ?>>
                                <?= $team->post_title ?></option>
                        <?php endforeach; ?>
                    </select>
                </td>
            </tr>
            <tr>
                <th><label for="sgc_event_tee"><?= __('Tee') ?></label></th>
                <td>
                    <select name="sgc_event_tee" id="sgc_event_tee">
                        <option value=""><?= __('Any Tee') ?></option>
                        <?php if ($tees) : foreach ($tees as $tee) : ?>
                            <option value="<?= $tee->color ?>" 
                                <?php selected($tee->color, $event_tee); ?>>
                                <?= $tee->color ?> (<?= $tee->difficulty ?>)</option>
                        <?php endforeach;endif; ?>
                    </select>
                </td>
            </tr>
            <tr>
                <th class="sgc-table-top"><label for="sgc_event_managegroups">
                        <?= __('Groups') ?></th>
                <td>
                    <a href="#TB_inline?width=600&height=550&inlineId=sgc_event_manage_groups" 
                       class="thickbox button" id="sgc_event_manage_button" 
                       name="<?= __('Manage Groups') ?>" group_list="#sgc_event_group_list" 
                       group_display="#sgc_group_display" team_select="#sgc_event_team">
                        <?= __('Manage Groups') ?></a>
                    <div id="sgc_event_group_summary" name="sgc_event_group_summary"></div>
                </td>
            </tr>
        </tbody>
    </table>
    <textarea name="sgc_event_group_list" id="sgc_event_group_list" style="display: none"><?= $event_groups ?></textarea>
</div>

<div id="sgc_event_manage_groups" style="display:none;">
    <div class="container" style="padding: 6px">
        <div style="float: right">
            <a href="" class="button-primary thickbox" id="sgc_event_group_save">
                <?= __('Save') ?></a>
        </div>
        <a href="" class="button-secondary thickbox" id="sgc_event_group_add" >
            <?= __('Add Group') ?></a>
        <div id="sgc_event_group_display" class="sgc-event-group-list"></div>
    </div>
</div>
