<?php
/**
 * Provide ui for entering in date/time
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://bitbucket.org/matthewlinton/
 * @since      1.0.0
 *
 * @package    Simplegolfclub
 * @subpackage Simplegolfclub/admin/partials
 */
?>

<input type="hidden" id="sgc_javascript" value="sgc_player">
<div class="sgc-container">
    <table class="formtable">
        <tbody>
            <tr>
                <th><label for="sgc_player_handicap"><?= __('Handicap') ?></label></th>
                <td><input type="text" name="sgc_player_handicap" id="sgc_player_handicap" 
                        value="<?= $player_handicap ?>" /></td>
            </tr>
            <tr>
                <th><label for="sgc_player_phone"><?= __('Phone') ?></label></th>
                <td><input type="text" name="sgc_player_phone" id="sgc_player_phone" 
                        value="<?= $player_phone ?>" /></td>
            </tr>
            <tr>
                <th><label for="sgc_player_email"><?= __('Email') ?></label></th>
                <td><input type="text" name="sgc_player_email" id="sgc_player_email" 
                        value="<?= $player_email ?>"></td>
            </tr>
            <tr>
                <th><label for="sgc_player_website"><?= __('Website') ?></label></th>
                <td><input type="text" name="sgc_player_website" id="sgc_player_website" 
                        value="<?= esc_url_raw($player_website) ?>"></td>
            </tr>
            <tr>
                <th class="sgc-table-top"><label for="sgc_player_team"><?= __('Teams') ?>
                    </label></th>
                <td>
                    <div class="sgc-container">
                        <select name="sgc_team_select" id="sgc_team_select">
                            <option value=""><?= __('Select Team...') ?></option>
                            <?php foreach ($teams as $team) : ?>
                                <option value="<?= $team->ID ?>" name="<?= $team->post_title ?>" 
                                        url="<?= get_the_permalink($team->ID) ?>"
                                        <?php selected($team->ID, $default_team); ?>>
                                        <?= $team->post_title ?></option>
                                    <?php endforeach; ?>
                        </select>
                        <a href="" class="button" id="sgc_player_add_team" 
                           source="#sgc_team_select"><?= __('Add') ?></a>
                    </div>
                    <div id="sgc_player_teams_display" class="sgc-player-teams">
                        <?php foreach ($player_teamlist as $team) : ?>
                            <div><a href="<?= $team['URL'] ?>" target="Team">
                                <?= $team['name'] ?></a></div>
                        <?php endforeach; ?>
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <textarea name="sgc_player_teams" id="sgc_player_teams" style="display: none">
        <?= json_encode($player_teamlist); ?></textarea>
</div>