<?php
/**
 * Provide UI for upcoming events widget
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://bitbucket.org/matthewlinton/
 * @since      1.0.0
 *
 * @package    Simplegolfclub
 * @subpackage Simplegolfclub/admin/partials
 */
?>

<div class="sgc-container">
    <div class="sgc-widget-events">
        <?php if (empty($events_past)) : ?>
            <h3><?= __('No Past Events') ?></h3>
        <?php else : ?>
            <h3><?= __('Past Events') ?></h3><hr>
        <?php endif; ?>
        <ul class="sgc-widget-events">
            <?php foreach ($events_past as $event) : ?>
                <li class="sgc-widget-event-item">
                    <b><?= get_post_meta($event->ID, 'sgc_event_date', true); ?> @
                        <?= get_post_meta($event->ID, 'sgc_event_time', true); ?></b><br>
                    <a href="<?= get_the_permalink($event->ID) ?>" target="_widget">
                        <?= $event->post_title ?></a>
                </li>
            <?php endforeach; ?>
        </ul>
    </div>

    <div class="sgc-widget-events" style="float: right;">
        <?php if (empty($events_upcoming)) : ?>
            <h3><?= __('No Upcoming Events') ?></h3>
        <?php else : ?>
            <h3><?= __('Upcoming Events') ?><hr></h3>
        <?php endif; ?>
        <ul class="sgc-widget-events">
            <?php foreach ($events_upcoming as $event) : ?>
                <li class="sgc-widget-event-item">
                    <b><?= get_post_meta($event->ID, 'sgc_event_date', true); ?> @
                        <?= get_post_meta($event->ID, 'sgc_event_time', true); ?></b><br> 
                    <a href="<?= get_the_permalink($event->ID) ?>" target="_widget">
                        <?= $event->post_title ?></a><br>
                </li>
            <?php endforeach; ?>
        </ul>
    </div>
</div>
